Subject: Re: phy address in the device tree, vs auto probing

From: Scott Wood <[email-masked]>
Date: Wed, 10 Feb 2010 12:28:02 -0600

Grant Likely wrote:
>> 1. What if we just don't specific a phy address with a reg property which would specify to auto probe it and find the phy as illustrated below?
>>
>>
>>                Ethernet_MAC: ethernet@81000000 {
>>                        #address-cells = <1>;
>>                        #size-cells = <1>;
>>                        phy-handle = <&phy0>;
>>                        mdio {
>>                                #address-cells = <1>;
>>                                #size-cells = <0>;
>>                                phy0: phy@7 {
>>                                } ;
>>                        } ;
>>
>> 2. Or a special value (-1 or something not 0 - 31) in the phy address that specifies to auto probe as illustrated below.
>>                                phy0: phy@7 {
>>                                        reg = <-1>;
>>                                } ;
> 
> I don't like abusing the reg property in this way.  I wonder if a new
> empty property would be a better way to indicate this.  Maybe
> "phy-probe-address;"?  It would also be important to specify in the
> binding that only one phy node is allowed when phy-probe-address is
> used.
> 
> Also, without a known reg the 'phy@7' name is inaccurate.  Drop the @7.
> 
> Scott, Andy: any thoughts?

I'm not fond of the -1.  I'd prefer the explicit phy-probe-address property, 
though I don't mind too much using the absence of reg.

-Scott